## VWO Node SDK

[![npm version](https://badge.fury.io/js/vwo-node-sdk.svg)](https://www.npmjs.com/package/vwo-node-sdk)
[![CI](https://github.com/wingify/vwo-node-sdk/workflows/CI/badge.svg?branch=master)](https://github.com/wingify/vwo-node-sdk/actions?query=workflow%3ACI)

[![codecov](https://codecov.io/gh/wingify/vwo-node-sdk/branch/master/graph/badge.svg?token=813UYYMWGM)](https://codecov.io/gh/wingify/vwo-node-sdk)

[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](http://www.apache.org/licenses/LICENSE-2.0)
![](http://img.badgesize.io/wingify/vwo-node-sdk/master/dist/vwo-javascript-sdk.min.js?compression=gzip&color=blue)

This open source library allows you to A/B Test your Website at server-side. This SDK can also be used on client-side i.e. browser.

### Requirements

- Node 6.10.0 or later - for server-side
- Latest browsers - for client-side

### Installation

**For NodeJs/JavasScript SDK**

```bash
# via npm
npm install vwo-node-sdk --save

# via yarn
yarn add vwo-node-sdk
```

**For client-side Javascript SDK**

There are multiple ways to load the library

1. As mentioned above i.e. install and bundle with the package
2. Can be downloaded from [GitHub](https://github.com/wingify/vwo-node-sdk/tree/master/dist)
3. Using script tag
    ```html
    <script src="/path/to/sdk"></script>
    ```

    Or can be downloaded from CDNs like [jsdelivr](https://www.jsdelivr.com/). Please check the docs how to reference the library/sdk version.

    ```html
    <script src="https://cdn.jsdelivr.net/npm/vwo-node-sdk@1/dist/vwo-javascript-sdk.min.js"></script>
    ```

### Documentation

Refer [Official VWO Documentation](https://developers.vwo.com/docs/fullstack-overview)

### Demo NodeJs application

[vwo-node-sdk-example](https://github.com/wingify/vwo-node-sdk-example)

### Third-party Resources and Credits

Refer [third-party-attributions.txt](https://github.com/wingify/vwo-node-sdk/blob/master/third-party-attributions.txt)

### Authors

* [Varun Malhotra](https://github.com/softvar) [@s0ftvar](https://twitter.com/s0ftvar)
* [Ishank Bahl](https://github.com/ishankbahl) [@ishankbahl97](https://twitter.com/ishankbahl97)

### Changelog

Refer [CHANGELOG.md](https://github.com/wingify/vwo-node-sdk/blob/master/CHANGELOG.md)

### Contributing

Please go through our [contributing guidelines](https://github.com/wingify/vwo-node-sdk/blob/master/CONTRIBUTING.md)

### Code of Conduct

[Code of Conduct](https://github.com/wingify/vwo-node-sdk/blob/master/CODE_OF_CONDUCT.md)

### License

[Apache License, Version 2.0](https://github.com/wingify/vwo-node-sdk/blob/master/LICENSE)

Copyright 2019-2022 Wingify Software Pvt. Ltd.
